<?php 
$controller = 'PosUnit';
$action = '';
if(isset($_POST['action'])){
    $action = $_POST['action'];
    if (isset($_POST['id'])) {$id = $_POST['id'];}
}elseif(isset($_GET['action'])){
    $action = $_GET['action'];
    if (isset($_GET['id'])) {$id = $_GET['id'];}
}
include $_SERVER["DOCUMENT_ROOT"].'/app/include/bootstrap.php';

$_form = new PosUnidadMedidaForm();
$_unidadMedida = new PosUnidadMedidaRepository();
$_listaUnidadesMedida = $_unidadMedida->getListaUnidadesMedida();

switch($action){
    case 'insert':
        $_form->populate($_POST);
        if($_form->isValid()){
            $_unidadMedida->setOptions($_POST);
            $result = $_unidadMedida->save($_unidadMedida->getOptions());
            if($result){
                $flashmessenger->addMessage(array('success'=>'Genial !! La Unidad de medida se registro exitosamente.'));
                header('Location: PosUnit.php');
            }else{
                $flashmessenger->addMessage(array('danger'=>'Error. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
            }
        }else{
            $vista = 'PosUnidadMedida.php';
            include $root.'/View/Template.php';
        }
        break;
   
    case 'edit':
        if($_GET){$_unidadMedidaData = $_unidadMedida->getById($id);}
        if($_POST){$_unidadMedidaData = $_POST;}
        
        $_form->setActionController('edit');
        $_form->setId($id);
        $_form->populate($_unidadMedidaData);
        
        if(isset($_POST['id'])){
            if($_form->isValid()){
                $_unidadMedida->setOptions($_unidadMedidaData);
                $result = $_unidadMedida->update($id,$_unidadMedida->getOptions()); //no tengo id porque viene de post
                if($result){
                    $flashmessenger->addMessage(array('success'=>'Estupendo !! La Unidad de medida se actualizo exitosamente.'));
                    header("Location: PosUnit.php?action=edit&id=$id");
                }else{
                    $flashmessenger->addMessage(array('danger'=>'Error. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
                }       
            }else{
                $vista = 'PosUnidadMedida.php';
                include $root . '/View/Template.php';
            }
        }else{
            $vista = 'PosUnidadMedida.php';
            include $root . '/View/Template.php';
        }        
        break;
    
    case 'delete': 
        if(!$_unidadMedida->isUsedInRecord($id)){
            if($_unidadMedida->delete($id)){
                $flashmessenger->addMessage(array('success'=>'Hecho !! La Unidad de medida fue eliminado satisfactoriamente.')); 
            }
        }else{
            $message = 'Hola !! este UnidadMedida no puede ser eliminado, esta siendo utilizado en almenos un registro.';
            $flashmessenger->addMessage(array('info'=>$message));
        }
        header('Location: PosUnit.php');
        break;
    
    default:
        $vista = 'PosUnidadMedida.php';
        include $root.'/View/Template.php';
}